image: docker:latest

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_TLS_CERTDIR: ""

services:
  - docker:19.03.1-dind

################################################################################
# Define stages
################################################################################
stages:
- verify
- build
- publish

################################################################################
# Setup environment
################################################################################
before_script:
  - docker info
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
  - apk add --no-cache bash git curl

################################################################################
# Build jobs
################################################################################
build_armv7l:
  tags:
    - armv7l
  environment: building_armv7l
  stage: build
  needs: ["check_tag_armv7l"]
  script:
    - ci/build.sh
  only:
  - merge_requests

build_x86_64:
  environment: building_x86_64
  stage: build
  needs: ["check_tag_x86_64"]
  script:
    - ci/build.sh
  only:
  - merge_requests

deploy_armv7l:
  tags:
    - armv7l
  environment: building_armv7l
  stage: publish
  needs: ["check_tag_armv7l"]
  script:
    - ci/build.sh
    - ci/deploy.sh
  only:
  - master

deploy_x86_64:
  environment: building_x86_64
  stage: publish
  needs: ["check_tag_x86_64"]
  script:
    - ci/build.sh
    - ci/deploy.sh
  only:
  - master

check_tag_armv7l:
  tags:
    - armv7l
  environment: building_armv7l
  stage: verify
  script:
    - ci/check.sh
  only:
  - merge_requests
  - master

check_tag_x86_64:
  environment: building_x86_64
  stage: verify
  script:
    - ci/check.sh
  only:
  - merge_requests
  - master
